package com.msl.xml;

import com.msl.FileContext;
import com.msl.NormalUpdater;
import org.javatuples.Pair;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wanglq
 * Date 2024/8/7
 * Time 13:20
 */
public class XmlNormalUpdater extends NormalUpdater {
    public static final List<Pair<String, String>> LIST = new ArrayList<>();

    static {
        //jdk相关
        LIST.add(Pair.with("<maven.compiler.source>8</maven.compiler.source>", "<maven.compiler.source>17</maven.compiler.source>"));
        LIST.add(Pair.with("<maven.compiler.target>8</maven.compiler.target>", "<maven.compiler.target>17</maven.compiler.target>"));
        LIST.add(Pair.with("<source>1.8</source>", "<source>17</source>"));
        LIST.add(Pair.with("<target>1.8</target>", "<target>17</target>"));
        LIST.add(Pair.with("<java.version>1.8</java.version>", "<java.version>17</java.version>"));

        LIST.add(Pair.with("<groupId>javax.validation</groupId>", "<groupId>jakarta.validation</groupId>"));
        LIST.add(Pair.with("<artifactId>validation-api</artifactId>", "<artifactId>jakarta.validation-api</artifactId>"));

        //druid
        LIST.add(Pair.with("<artifactId>druid-spring-boot-starter</artifactId>", "<artifactId>druid-spring-boot-3-starter</artifactId>"));
    }

    /**
     * 能否更新文件
     *
     * @param context 文件上下文
     * @return 能否更新
     */
    @Override
    public boolean canApply(FileContext context) {
        return context.getFileName().endsWith(".xml");
    }

    @Override
    protected List<Pair<String, String>> replaceList() {
        return LIST;
    }
}
